﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;
using System.Threading;
using System.Collections;
using System.Runtime.InteropServices;

namespace IRReceiver
{
    public partial class Form1 : Form
    {

        static SerialPort _serialPort;
        Dictionary <string,int[]> Buttons;

        
        //Sendinput dll
        [DllImport("user32.dll", SetLastError = true)]
        static extern uint SendInput(uint nInputs, ref INPUT pInputs, int cbSize);

        public enum VK : ushort
    {
    SHIFT        = 0x10,
    CONTROL          = 0x11,
    MENU         = 0x12,
    ESCAPE           = 0x1B,
    BACK         = 0x08,
    TAB          = 0x09,
    RETURN           = 0x0D,
    PRIOR        = 0x21,
    NEXT         = 0x22,
    END          = 0x23,
    HOME         = 0x24,
    LEFT         = 0x25,
    UP           = 0x26,
    RIGHT        = 0x27,
    DOWN         = 0x28,
    SELECT           = 0x29,
    PRINT        = 0x2A,
    EXECUTE          = 0x2B,
    SNAPSHOT         = 0x2C,
    INSERT           = 0x2D,
    DELETE           = 0x2E,
    HELP         = 0x2F,
    NUMPAD0          = 0x60,
    NUMPAD1          = 0x61,
    NUMPAD2          = 0x62,
    NUMPAD3          = 0x63,
    NUMPAD4          = 0x64,
    NUMPAD5          = 0x65,
    NUMPAD6          = 0x66,
    NUMPAD7          = 0x67,
    NUMPAD8          = 0x68,
    NUMPAD9          = 0x69,
    MULTIPLY         = 0x6A,
    ADD          = 0x6B,
    SEPARATOR        = 0x6C,
    SUBTRACT         = 0x6D,
    DECIMAL          = 0x6E,
    DIVIDE           = 0x6F,
    F1           = 0x70,
    F2           = 0x71,
    F3           = 0x72,
    F4           = 0x73,
    F5           = 0x74,
    F6           = 0x75,
    F7           = 0x76,
    F8           = 0x77,
    F9           = 0x78,
    F10          = 0x79,
    F11          = 0x7A,
    F12          = 0x7B,
    OEM_1        = 0xBA,   // ',:' for US
    OEM_PLUS         = 0xBB,   // '+' any country
    OEM_COMMA        = 0xBC,   // ',' any country
    OEM_MINUS        = 0xBD,   // '-' any country
    OEM_PERIOD       = 0xBE,   // '.' any country
    OEM_2        = 0xBF,   // '/?' for US
    OEM_3        = 0xC0,   // '`~' for US
    MEDIA_NEXT_TRACK     = 0xB0,
    MEDIA_PREV_TRACK     = 0xB1,
    MEDIA_STOP           = 0xB2,
    MEDIA_PLAY_PAUSE     = 0xB3,
    PLAY                 = 0xFA ,             
           

    LWIN       =0x5B,
    RWIN       =0x5C,
            
    A = 0X41,
    B = 0X42,
    C = 0X43,
    D = 0X44,
    E = 0X45,
    F = 0X46,
    G = 0X47,
    H = 0X48,
    I = 0X49,
    J = 0X4A,
    K = 0X4B,
    L = 0X4C,
    M = 0X4D,
    N = 0X4E,
    O = 0X4F,
    P = 0X50,
    Q = 0X51,
    R = 0X52,
    S = 0X53,
    T = 0X54,
    U = 0X55,
    V = 0X56,
    W = 0X57,
    X = 0X58,
    Y = 0X59,
    Z = 0X5A


    }

    public struct KEYBDINPUT
    {
    public ushort wVk;
    public ushort wScan;
    public uint dwFlags;
    public long time;
    public uint dwExtraInfo;
    };

    [StructLayout(LayoutKind.Explicit, Size = 28)]
    public struct INPUT
    {
        [FieldOffset(0)]
        public uint type;
        [FieldOffset(4)]
        public KEYBDINPUT ki;
    };

    public enum InputTypes
    {
        // For use with the INPUT struct, see SendInput for an example
        INPUT_MOUSE = 0,
        INPUT_KEYBOARD = 1,
        INPUT_HARDWARE = 2
    }

    public enum KEYEVENTF 
    {

        // For use with the INPUT struct, see SendInput for an example
        IEXTENDEDKEY = 1,
        KEYUP = 2,
        UNICODE = 4,//[unicode]???
        SCANCODE = 8
    }





        public Form1()
        {

            InitializeComponent();
            foreach (string s in SerialPort.GetPortNames())
            {
                portName.Items.Add(s.ToString());
            }

            _serialPort = new SerialPort();

            if (Properties.Settings.Default.portname != "")
            {
                if (portName.Items.Contains(Properties.Settings.Default.portname))
                {
                    portName.SelectedIndex = portName.Items.IndexOf(Properties.Settings.Default.portname);
                    openSerialPort();
                    
                }

            }


            Buttons = new Dictionary<string, int[]>();

            Buttons.Add("Button_1", new int [] { 0, 9116, 13564, 14188, 15812, 16440, 16924, 17548, 19168, 19796, 20276, 20908, 21388, 22016, 22500, 23128, 23612, 24240, 25856, 26484, 26968, 27592, 28080, 28704, 29188, 29816, 30300, 30932, 32544, 33172, 34792, 35420, 35904, 36532, 37016, 37644, 38124, 38752, 39232, 39864, 40344, 40972, 42592, 43220, 43704, 44332, 45948, 46576, 47060, 47688, 48168, 48796, 49280, 49908, 50388, 51020, 51500, 52128, 52608, 53240, 54860, 55484, 55968, 56596 });
            Buttons.Add("Button_2", new int [] { 4, 9120, 13568, 14196, 15812, 16444, 16924, 17552, 19172, 19800, 20284, 20912, 21392, 22020, 22500, 23128, 23612, 24240, 25860, 26488, 26968, 27600, 28080, 28708, 29188, 29816, 30300, 30928, 32548, 33172, 34792, 35424, 35904, 36532, 37016, 37640, 39264, 39864, 40372, 40976, 41484, 42084, 43732, 44336, 44844, 45444, 47088, 47688, 48200, 48800, 49308, 49908, 50420, 51020, 51528, 52132, 52640, 53244, 53752, 54348, 55996, 56600, 57108, 57708 });
            Buttons.Add("Button_3", new int [] { 0, 9116, 13560, 14192, 15808, 16436, 16920, 17548, 19164, 19792, 20276, 20904, 21388, 22016, 22496, 23124, 23608, 24236, 25856, 26480, 26964, 27592, 28076, 28700, 29188, 29812, 30296, 30924, 32544, 33172, 34792, 35416, 35900, 36524, 37012, 37612, 38120, 38724, 40368, 40972, 41480, 42080, 43728, 44328, 44836, 45436, 47084, 47688, 48192, 48796, 49304, 49904, 50416, 51016, 51524, 52124, 52636, 53236, 53748, 54348, 55996, 56596, 57104, 57704 });
            Buttons.Add("Button_4", new int [] { 0, 9120, 13568, 14196, 15812, 16440, 16924, 17552, 19168, 19800, 20280, 20908, 21388, 22020, 22500, 23128, 23612, 24240, 25860, 26488, 26972, 27600, 28080, 28704, 29192, 29816, 30300, 30928, 32544, 33172, 34796, 35424, 35904, 36532, 37016, 37644, 39260, 39888, 41508, 42136, 42620, 43248, 44868, 45496, 45976, 46604, 48228, 48852, 49336, 49960, 50444, 51072, 51560, 52184, 52668, 53292, 53776, 54404, 54888, 55516, 57132, 57756, 58244, 58868 });
            Buttons.Add("Button_5", new int [] { 0, 9108, 13564, 14188, 15812, 16436, 16920, 17548, 19172, 19796, 20280, 20904, 21392, 22016, 22504, 23128, 23608, 24236, 25860, 26484, 26968, 27592, 28076, 28704, 29188, 29816, 30300, 30924, 32548, 33176, 34796, 35420, 35904, 36532, 37012, 37644, 38124, 38752, 39236, 39864, 41484, 42112, 43732, 44360, 44840, 45472, 47088, 47740, 48200, 48852, 49312, 49940, 50420, 51048, 51528, 52184, 52640, 53292, 53748, 54404, 55996, 56652, 57108, 57764 });
            Buttons.Add("Button_6", new int [] { 0, 9116, 13568, 14192, 15812, 16440, 16924, 17552, 19168, 19796, 20280, 20908, 21392, 22020, 22500, 23128, 23612, 24240, 25860, 26488, 26968, 27600, 28080, 28712, 29192, 29820, 30300, 30932, 32548, 33180, 34796, 35424, 35904, 36556, 37016, 37672, 39264, 39892, 40376, 41024, 42620, 43272, 44868, 45496, 45980, 46608, 48228, 48880, 49336, 49988, 50448, 51100, 51560, 52212, 52668, 53320, 53780, 54432, 54888, 55520, 57136, 57788, 58248, 58876 });
            Buttons.Add("Button_7", new int [] { 0, 9084, 13564, 14188, 15812, 16436, 16924, 17548, 19172, 19796, 20280, 20908, 21392, 22016, 22504, 23128, 23612, 24240, 25856, 26484, 26972, 27592, 28080, 28708, 29188, 29816, 30300, 30928, 32548, 33176, 34792, 35420, 35908, 36532, 37016, 37644, 38128, 38752, 40372, 41000, 42620, 43248, 44868, 45496, 45980, 46604, 48228, 48852, 49336, 49964, 50448, 51076, 51560, 52184, 52664, 53296, 53780, 54404, 54888, 55516, 57136, 57764, 58248, 58876 });
            Buttons.Add("Button_8", new int [] { 0, 9116, 13564, 14192, 15812, 16440, 16924, 17548, 19172, 19796, 20284, 20912, 21392, 22016, 22504, 23128, 23616, 24240, 25860, 26488, 26972, 27600, 28084, 28708, 29192, 29820, 30304, 30952, 32548, 33176, 34796, 35448, 35908, 36560, 37016, 37672, 39264, 39916, 41512, 42164, 43760, 44416, 46008, 46660, 47116, 47772, 49364, 50016, 50476, 51104, 51584, 52240, 52696, 53352, 53808, 54460, 54916, 55568, 56028, 56680, 58276, 58924, 59384, 60012 });
            Buttons.Add("Button_9", new int [] { 0, 9036, 13568, 14112, 15816, 16360, 16924, 17472, 19172, 19720, 20284, 20828, 21396, 21940, 22504, 23048, 23616, 24160, 25860, 26408, 26972, 27516, 28084, 28628, 29196, 29760, 30304, 30872, 32552, 33116, 34796, 35364, 35912, 36476, 37020, 37612, 38128, 38720, 39240, 39832, 40352, 40944, 41460, 42056, 43708, 44304, 45956, 46548, 47068, 47660, 48176, 48772, 49288, 49880, 50396, 50992, 51508, 52104, 52620, 53216, 53728, 54348, 54840, 55460 });
            Buttons.Add("Button_0", new int [] { 4, 9040, 13564, 14112, 15812, 16360, 16924, 17468, 19172, 19716, 20280, 20828, 21392, 21940, 22504, 23048, 23616, 24160, 25860, 26408, 26972, 27516, 28084, 28648, 29192, 29740, 30304, 30872, 32548, 33116, 34796, 35364, 35908, 36496, 37020, 37608, 39268, 39860, 40380, 40968, 41484, 42080, 42596, 43192, 44844, 45436, 47092, 47688, 48204, 48796, 49316, 49908, 50424, 51020, 51536, 52128, 52648, 53264, 53752, 54372, 54868, 55488, 55976, 56600 });
            Buttons.Add("Button_Clear", new int [] { 0, 9112, 13568, 14192, 15816, 16440, 16924, 17552, 19172, 19800, 20284, 20908, 21392, 22020, 22504, 23132, 23616, 24240, 25860, 26492, 26972, 27600, 28080, 28708, 29192, 29820, 30304, 30932, 32552, 33180, 34800, 35424, 35908, 36564, 37020, 37648, 38128, 38760, 40376, 41008, 41488, 42116, 42600, 43228, 44844, 45500, 47100, 47748, 48204, 48856, 49312, 49968, 50424, 51076, 51536, 52192, 52648, 53300, 53756, 54408, 54868, 55520, 55976, 56628 });
            Buttons.Add("Button_Enter", new int [] { 0, 9116, 13568, 14188, 15812, 16440, 16924, 17548, 19172, 19796, 20284, 20908, 21392, 22016, 22504, 23128, 23616, 24240, 25860, 26488, 26972, 27600, 28084, 28708, 29192, 29820, 30304, 30928, 32548, 33176, 34800, 35428, 35908, 36532, 37020, 37648, 39268, 39892, 41512, 42140, 42624, 43252, 43736, 44360, 45980, 46608, 48232, 48880, 49340, 49992, 50452, 51080, 51564, 52212, 52672, 53324, 53784, 54436, 54892, 55548, 56000, 56656, 57112, 57768 });
            Buttons.Add("Button_Play", new int [] { 0, 9120, 13568, 14200, 15816, 16444, 16928, 17556, 19172, 19804, 20288, 20916, 21396, 22028, 22508, 23136, 23616, 24248, 25864, 26492, 26976, 27604, 28088, 28716, 29196, 29828, 30308, 30936, 32552, 33180, 34800, 35432, 35916, 36540, 37024, 37652, 39272, 39900, 40380, 41008, 41492, 42120, 42604, 43232, 43712, 44340, 45960, 46588, 47072, 47696, 48180, 48784, 49292, 49896, 50404, 51008, 51516, 52116, 52628, 53228, 54872, 55472, 55984, 56584 });
            Buttons.Add("Button_Rew", new int [] { 0, 9124, 13568, 14196, 15816, 16448, 16928, 17556, 19176, 19804, 20284, 20916, 21396, 22028, 22508, 23136, 23616, 24244, 25868, 26496, 26976, 27604, 28088, 28716, 29200, 29828, 30308, 30936, 32556, 33180, 34804, 35432, 35916, 36544, 37024, 37652, 38136, 38760, 40380, 41008, 41492, 42120, 42604, 43232, 43716, 44340, 45960, 46592, 47076, 47708, 48184, 48808, 49296, 49920, 50408, 51032, 51512, 52144, 52624, 53252, 54876, 55476, 55984, 56584 });
            Buttons.Add("Button_Pause", new int [] { 0, 9124, 13572, 14196, 15820, 16448, 16932, 17560, 19176, 19804, 20288, 20916, 21396, 22024, 22508, 23136, 23620, 24248, 25864, 26496, 26976, 27608, 28092, 28716, 29200, 29824, 30312, 30936, 32556, 33184, 34804, 35432, 35924, 36540, 37024, 37652, 39276, 39900, 41524, 42148, 42632, 43260, 43744, 44344, 44852, 45456, 47100, 47704, 48212, 48816, 49324, 49924, 50432, 51032, 51544, 52144, 52652, 53256, 53764, 54364, 56012, 56616, 57124, 57724 });
            Buttons.Add("Button_Forward", new int [] { 0, 9120, 13568, 14196, 15812, 16448, 16928, 17556, 19176, 19800, 20284, 20912, 21396, 22024, 22508, 23136, 23616, 24248, 25864, 26492, 26976, 27600, 28088, 28712, 29196, 29824, 30308, 30932, 32556, 33184, 34800, 35428, 35912, 36540, 37024, 37652, 38132, 38760, 39244, 39872, 41492, 42116, 42600, 43228, 43712, 44340, 45960, 46564, 47072, 47672, 48184, 48784, 49296, 49896, 50404, 51004, 51516, 52116, 52628, 53228, 54872, 55472, 55984, 56584 });
            Buttons.Add("Button_Slow", new int [] { 0, 9120, 13568, 14200, 15816, 16448, 16928, 17556, 19176, 19804, 20288, 20916, 21400, 22028, 22508, 23132, 23620, 24244, 25868, 26492, 26976, 27604, 28088, 28716, 29200, 29828, 30308, 30936, 32556, 33184, 34804, 35428, 35916, 36540, 37028, 37648, 39272, 39896, 40388, 40988, 42632, 43232, 43744, 44344, 44852, 45452, 47104, 47704, 48212, 48812, 49324, 49924, 50432, 51032, 51544, 52144, 52656, 53252, 53764, 54364, 56012, 56616, 57124, 57724 });
            Buttons.Add("Button_Back", new int [] { 0, 9116, 13568, 14196, 15816, 16444, 16928, 17552, 19176, 19800, 20288, 20912, 21396, 22024, 22508, 23132, 23620, 24244, 25868, 26492, 26976, 27604, 28088, 28712, 29200, 29824, 30308, 30936, 32556, 33184, 34804, 35432, 35912, 36540, 37024, 37652, 38136, 38764, 40380, 41012, 42632, 43280, 43744, 44368, 44856, 45480, 47100, 47728, 48212, 48840, 49324, 49948, 50436, 51088, 51544, 52172, 52656, 53308, 53764, 54416, 56012, 56668, 57120, 57776 });
            Buttons.Add("Button_Skip", new int [] { 0, 9040, 13572, 14164, 15816, 16416, 16928, 17524, 19176, 19772, 20288, 20884, 21400, 21996, 22512, 23108, 23620, 24220, 25868, 26488, 26980, 27600, 28092, 28712, 29200, 29800, 30312, 30932, 32560, 33184, 34804, 35432, 35920, 36544, 37032, 37656, 39276, 39928, 41524, 42176, 43776, 44424, 44884, 45536, 45992, 46648, 48240, 48892, 49352, 50004, 50460, 51112, 51576, 52228, 52684, 53336, 53796, 54448, 54904, 55560, 57156, 57808, 58264, 58916 });
            Buttons.Add("Button_Chan_Up", new int [] { 0, 9120, 13572, 14200, 15816, 16444, 16928, 17556, 19176, 19804, 20288, 20916, 21400, 22024, 22508, 23136, 23620, 24248, 25868, 26496, 26980, 27608, 28088, 28716, 29200, 29828, 30312, 30940, 32556, 33188, 34808, 35436, 35916, 36548, 37028, 37656, 38140, 38768, 40388, 41016, 42632, 43260, 44884, 45508, 47132, 47756, 48240, 48868, 49352, 49976, 50464, 51088, 51576, 52200, 52684, 53308, 53796, 54420, 54908, 55532, 56016, 56640, 58264, 58892 });
            Buttons.Add("Button_Chan_Down", new int [] { 0, 9116, 13568, 14196, 15816, 16444, 16928, 17552, 19172, 19800, 20288, 20912, 21396, 22024, 22508, 23132, 23616, 24248, 25868, 26496, 26976, 27604, 28088, 28716, 29200, 29828, 30308, 30936, 32556, 33188, 34804, 35436, 35916, 36544, 37024, 37652, 39276, 39904, 41524, 42152, 43772, 44400, 46020, 46648, 48268, 48896, 49380, 50008, 50488, 51116, 51600, 52228, 52712, 53340, 53820, 54448, 54932, 55560, 56044, 56672, 57156, 57780, 59400, 60052 });
            Buttons.Add("Button_Rec", new int [] { 0, 9120, 13576, 14200, 15820, 16448, 16932, 17560, 19180, 19812, 20292, 20920, 21404, 22032, 22516, 23144, 23624, 24252, 25872, 26504, 26984, 27612, 28096, 28724, 29208, 29832, 30320, 30948, 32568, 33196, 34812, 35444, 35928, 36556, 37036, 37664, 38144, 38776, 39256, 39888, 40372, 40996, 41480, 42108, 42592, 43220, 44840, 45468, 45952, 46580, 47060, 47692, 48172, 48800, 49284, 49912, 50392, 51024, 51508, 52132, 53752, 54380, 54864, 55496 });
            Buttons.Add("Button_Thumbs_Down", new int [] { 0, 9116, 13572, 14196, 15820, 16444, 16932, 17556, 19176, 19804, 20288, 20920, 21400, 22028, 22512, 23136, 23624, 24248, 25868, 26496, 26980, 27608, 28096, 28720, 29204, 29828, 30316, 30944, 32564, 33192, 34812, 35440, 35920, 36552, 37032, 37660, 38144, 38772, 39252, 39884, 40364, 40992, 42612, 43240, 44860, 45492, 45976, 46616, 47084, 47712, 48196, 48824, 49308, 49960, 50416, 51072, 51528, 52180, 52640, 53292, 53748, 54404, 56000, 56652 });
            Buttons.Add("Button_Thumbs_Up", new int [] { 0, 9112, 13568, 14192, 15816, 16440, 16928, 17552, 19176, 19800, 20288, 20912, 21400, 22024, 22512, 23136, 23620, 24248, 25868, 26496, 26980, 27604, 28092, 28720, 29200, 29832, 30312, 30940, 32560, 33188, 34808, 35440, 35924, 36548, 37032, 37660, 38144, 38768, 40392, 41020, 41504, 42128, 43752, 44376, 46000, 46652, 47108, 47740, 48220, 48848, 49332, 49988, 50444, 51096, 51552, 52208, 52664, 53292, 53776, 54428, 54888, 55540, 57136, 57788 });
            Buttons.Add("Button_Sel", new int [] { 0, 9124, 13572, 14200, 15820, 16448, 16932, 17560, 19180, 19808, 20292, 20920, 21404, 22028, 22516, 23144, 23624, 24256, 25872, 26500, 26984, 27612, 28096, 28724, 29204, 29832, 30316, 30944, 32564, 33192, 34812, 35440, 35928, 36552, 37036, 37664, 39280, 39912, 40396, 41024, 41508, 42136, 43752, 44384, 46004, 46632, 47112, 47744, 48224, 48852, 49332, 49964, 50448, 51072, 51560, 52184, 52668, 53296, 53780, 54404, 54892, 55516, 57136, 57764 });

            Buttons.Add("Button_Up", new int[] { 0, 9132, 13584, 14212, 15832, 16464, 16948, 17548, 19200, 19800, 20308, 20916, 21424, 22028, 22536, 23136, 23644, 24248, 25896, 26496, 27008, 27612, 28120, 28724, 29228, 29836, 30340, 30948, 32596, 33196, 34844, 35444, 35952, 36556, 37064, 37668, 38180, 38780, 39292, 39892, 41540, 42144, 42652, 43256, 44900, 45504, 46016, 46616, 47128, 47728, 48240, 48840, 49352, 49924, 50464, 51040, 51576, 52144, 52688, 53260, 53796, 54372, 56048, 56620, });
            Buttons.Add("Button_Down", new int[] { 0, 9068, 13584, 14180, 15832, 16428, 16944, 17540, 19192, 19792, 20308, 20904, 21420, 22016, 22532, 23128, 23644, 24240, 25896, 26492, 27004, 27604, 28120, 28716, 29232, 29852, 30344, 30964, 32592, 33216, 34840, 35468, 35956, 36580, 37064, 37688, 38176, 38804, 40428, 41052, 42676, 43304, 43792, 44420, 46040, 46668, 47152, 47784, 48264, 48892, 49376, 50004, 50484, 51120, 51600, 52228, 52712, 53340, 53824, 54452, 54936, 55564, 57184, 57816, });
            Buttons.Add("Button_Left", new int[] { 0, 9124, 13580, 14208, 15832, 16460, 16944, 17572, 19192, 19820, 20304, 20936, 21420, 22044, 22528, 23160, 23640, 24276, 25892, 26520, 27004, 27632, 28112, 28740, 29228, 29856, 30340, 30968, 32588, 33220, 34840, 35468, 35948, 36580, 37064, 37692, 39312, 39940, 41560, 42192, 43812, 44444, 44928, 45556, 47176, 47804, 48284, 48940, 49400, 50032, 50508, 51144, 51624, 52252, 52736, 53364, 53844, 54480, 54960, 55588, 56068, 56728, 58320, 58952, });
            Buttons.Add("Button_Right", new int[] { 0, 9068, 13584, 14176, 15832, 16428, 16944, 17540, 19196, 19788, 20308, 20900, 21420, 22016, 22532, 23128, 23644, 24240, 25892, 26488, 27004, 27600, 28116, 28712, 29228, 29824, 30340, 30936, 32588, 33188, 34840, 35440, 35952, 36552, 37064, 37664, 39312, 39920, 40428, 41028, 42680, 43300, 43792, 44412, 46040, 46664, 47152, 47776, 48264, 48888, 49376, 50000, 50488, 51116, 51600, 52228, 52712, 53336, 53824, 54448, 54936, 55560, 57184, 57812, });
            Buttons.Add("Button_Window", new int [] { 	0,9128,13584,14212,15832,16460,16944,17576,19192,19824,20308,20936,21420,22048,22528,23156,23644,24272,25892,26520,27004,27632,28120,28748,29228,29856,30340,30968,32592,33220,34840,35468,35952,36580,37064,37692,38176,38804,39288,39916,41536,42168,42652,43276,43760,44392,44876,45500,47124,47752,48236,48864,49348,49980,50460,51088,51572,52200,52680,53316,54932,55564,57184,57812,	});
            Buttons.Add("Button_Guide", new int[] { 0, 9072, 13580, 14152, 15824, 16400, 16936, 17512, 19188, 19764, 20300, 20876, 21412, 21988, 22528, 23096, 23636, 24208, 25888, 26460, 27000, 27572, 28108, 28684, 29220, 29796, 30332, 30908, 32584, 33156, 34832, 35404, 35944, 36516, 37056, 37628, 38168, 38740, 40416, 40992, 42664, 43240, 43780, 44352, 46028, 46604, 48276, 48852, 49388, 49960, 50500, 51072, 51616, 52188, 52728, 53300, 53840, 54408, 54948, 55520, 56060, 56636, 57172, 57748, });
            Buttons.Add("Button_Info", new int[] { 0, 9132, 13580, 14212, 15832, 16464, 16944, 17572, 19192, 19824, 20304, 20936, 21416, 22044, 22528, 23160, 23640, 24272, 25888, 26520, 27004, 27632, 28112, 28744, 29224, 29856, 30340, 30968, 32588, 33216, 34836, 35464, 35948, 36580, 37060, 37688, 39308, 39940, 41556, 42188, 42672, 43300, 43780, 44412, 46032, 46660, 47144, 47772, 48256, 48884, 49364, 49996, 50480, 51084, 51592, 52192, 52704, 53304, 53812, 54416, 54924, 55532, 57176, 57780, });
            Buttons.Add("Button_Live_TV", new int[] { 0, 9128, 13580, 14212, 15828, 16460, 16944, 17572, 19192, 19820, 20308, 20936, 21420, 22048, 22528, 23156, 23640, 24272, 25892, 26520, 27004, 27632, 28116, 28744, 29228, 29860, 30340, 30968, 32588, 33220, 34840, 35472, 35952, 36580, 37060, 37692, 39316, 39968, 40424, 41080, 41536, 42192, 42648, 43304, 44900, 45556, 46012, 46664, 47124, 47752, 48236, 48888, 49344, 50000, 50460, 51112, 51568, 52228, 52684, 53340, 53796, 54448, 56044, 56700, });

            Buttons.Add("Button_Tivo", new int[] { 0, 9124, 13572, 14200, 15816, 16448, 16928, 17560, 19176, 19804, 20288, 20916, 21400, 22028, 22508, 23136, 23620, 24248, 25868, 26496, 26980, 27608, 28092, 28720, 29204, 29828, 30312, 30940, 32560, 33188, 34812, 35412, 35920, 36548, 37028, 37636, 39280, 39884, 41528, 42128, 43776, 44376, 44888, 45488, 46000, 46600, 47112, 47712, 48216, 48824, 49328, 49936, 50440, 51044, 51552, 52152, 52660, 53264, 53772, 54376, 56024, 56624, 58268, 58872, });











        }

       
        
        


        
       
        
        
            


 

        private void portName_SelectedIndexChanged(object sender, EventArgs e)
        {
            
            Properties.Settings.Default.portname = portName.Text;
            Properties.Settings.Default.Save();
            openSerialPort();

        }


        private void openSerialPort()
        {
            try
            {
                if (_serialPort.IsOpen)
                {
                    _serialPort.Close();
                }


                _serialPort.PortName = portName.Text;
                _serialPort.BaudRate = 115200;
                _serialPort.Parity = Parity.None;
                _serialPort.DataBits = 8;
                _serialPort.StopBits = StopBits.One;
                _serialPort.Handshake = Handshake.None;

                _serialPort.ReadTimeout = 100;

                _serialPort.Open();

                _serialPort.DataReceived += new SerialDataReceivedEventHandler(serialDataReceived);
            }
            catch (Exception e)
            {
                MessageBox.Show(e.ToString());
            }


        }

        private void  serialDataReceived(object sender, SerialDataReceivedEventArgs e)
        {
            try
            {
                string IRcode = (_serialPort.ReadLine());
                string buttonPressed = decode(IRcode);
                virtualKeyboard(buttonPressed);
            }
            catch (Exception ex) 
            { 
            
            
            }


           

        }

        

        string decode(string IRCode)
        {
            string [] IRCodeStringArray = IRCode.Split(',');


            foreach (KeyValuePair<string, int[]> key in Buttons)
            {
                int[] IRValues = key.Value;
                bool found = true;

                for (int x = 0; x < 60; x++)//IRCodeStringArray.Length-1
                {
                    int currentIRValue= Convert.ToInt32(IRCodeStringArray[x]);

                    if (IRValues[x] - 100 <= currentIRValue && currentIRValue <= IRValues[x] + 100)                    {
                        continue;
                    }
                    else
                    {
                        found = false;
                        break;
                    }
                    
                }

                if (found)
                {
                    return key.Key;
                    //MessageBox.Show(key.Key);
                }

            }

            return "";
                   
        }


        void virtualKeyboard(string buttonPressed)
        {

            bool Shift = false;
            bool Ctrl = false;
            bool Alt = false;
            bool Win = false;
            
            uint intReturn;
            INPUT structInput = new INPUT();

            structInput.ki.wScan = 0;
            structInput.ki.time = 0;
            structInput.ki.dwFlags = 0;

            structInput.type = (int)InputTypes.INPUT_KEYBOARD;

            ushort keycode = 0;
            
            switch (buttonPressed)
            {
                case "Button_1":
                    keycode = (ushort)VK.NUMPAD1;
                    break;

                case "Button_2":
                    keycode = (ushort)VK.NUMPAD2;
                    break;

                case "Button_3":
                    keycode = (ushort)VK.NUMPAD3;
                    break;
                
                case "Button_4":
                    keycode = (ushort)VK.NUMPAD4;
                    break;

                case "Button_5":
                    keycode = (ushort)VK.NUMPAD5;
                    break;

                case "Button_6":
                    keycode = (ushort)VK.NUMPAD6;
                    break;

                case "Button_7":
                    keycode = (ushort)VK.NUMPAD7;
                    break;

                case "Button_8":
                    keycode = (ushort)VK.NUMPAD8;
                    break;

                case "Button_9":
                    keycode = (ushort)VK.NUMPAD9;
                    break;

                case "Button_0":
                    keycode = (ushort)VK.NUMPAD0;
                    break;

                case "Button_Clear":
                    keycode = (ushort)VK.BACK;
                    break;
                
                case "Button_Enter":
                    keycode = (ushort)VK.RETURN;
                    break;

                case "Button_Play":
                    keycode = (ushort)VK.P;
                    Ctrl = true;
                    Shift = true;
                    break;

                case "Button_Rew":
                    keycode = (ushort)VK.B;
                    Ctrl = true;
                    Shift = true;
                    break;

                case "Button_Pause":
                    //SendKeys.SendWait("^P");
                    keycode = (ushort)VK.MEDIA_PLAY_PAUSE;
                    break;

                case "Button_Forward":
                    keycode = (ushort)VK.F;
                    Ctrl = true;
                    Shift = true;
                    break;

                //case "Button_Slow":
                    //SendKeys.SendWait("0");
                    //break;

                case "Button_Back":
                    keycode = (ushort)VK.MEDIA_PREV_TRACK;
                    break;

                case "Button_Skip":
                    keycode = (ushort)VK.MEDIA_NEXT_TRACK;
                    break;

                case "Button_Chan_Up":
                    keycode = (ushort)VK.PRIOR;
                    break;

                case "Button_Chan_Down":
                    keycode = (ushort)VK.NEXT;
                    break;

                case "Button_Rec":
                    keycode = (ushort)VK.R;
                    Ctrl=true;
                    break;

                case "Button_Thumbs_Down":
                    keycode = (ushort)VK.BACK;
                    break;

                
                case "Button_Thumbs_Up":
                    keycode = (ushort)VK.O;
                    Ctrl = true;
                    break;
                

                case "Button_Sel":
                    keycode = (ushort)VK.RETURN;
                    break;

                case "Button_Up":
                    keycode = (ushort)VK.UP;
                    break;

                case "Button_Down":
                    keycode = (ushort)VK.DOWN;
                    break;

                case "Button_Left":
                    keycode = (ushort)VK.LEFT;
                    break;

                case "Button_Right":
                    keycode = (ushort)VK.RIGHT;
                    break;

                case "Button_Window":
                    //SendKeys.SendWait("0");
                    break;

                case "Button_Guide":
                    keycode = (ushort)VK.G;
                    Ctrl = true;
                    break;

                case "Button_Info":
                    keycode = (ushort)VK.D;
                    Ctrl = true;
                    break;

                case "Button_Live_TV":
                    keycode = (ushort)VK.T;
                    Ctrl = true;
                    break;

                case "Button_Tivo":
                    //SendKeys.SendWait("%({LWIN}{ENTER})");
                    keycode = (ushort)VK.RETURN;
                    Alt = true;
                    Win = true;

                    break;



            }


            // Key down shift, ctrl, and/or alt
            structInput.ki.wScan = 0;
            structInput.ki.time = 0;
            structInput.ki.dwFlags = 0;
            if (Shift)
            {
                structInput.ki.wVk = (ushort)VK.SHIFT;
                intReturn = SendInput(1, ref structInput, Marshal.SizeOf(new INPUT()));
            }
            if (Ctrl)
            {
                structInput.ki.wVk = (ushort)VK.CONTROL;
                intReturn = SendInput(1, ref structInput, Marshal.SizeOf(new INPUT()));
            }
            if (Alt)
            {
                structInput.ki.wVk = (ushort)VK.MENU;
                intReturn = SendInput(1, ref structInput, Marshal.SizeOf(new INPUT()));
            }
            if (Win)
            {
                structInput.ki.wVk = (ushort)VK.LWIN;
                intReturn = SendInput(1, ref structInput, Marshal.SizeOf(new INPUT()));
            }
            // Key down the actual key-code
            if (keycode != 0)
            {
                structInput.ki.wVk = keycode;
                intReturn = SendInput(1, ref structInput, Marshal.SizeOf(new INPUT()));
            }
            
            
            // Key up the actual key-code
            structInput.ki.dwFlags = (uint) KEYEVENTF.KEYUP;
            intReturn = SendInput(1, ref structInput, Marshal.SizeOf(typeof(INPUT)));// Marshal.SizeOf(new INPUT()));
            
             //Key up shift, ctrl, and/or alt
            if (Shift)
            {
                structInput.ki.wVk = (ushort)VK.SHIFT;
                intReturn = SendInput(1, ref structInput, Marshal.SizeOf(new INPUT()));
            }
            if (Ctrl)
            {
                structInput.ki.wVk = (ushort)VK.CONTROL;
                intReturn = SendInput(1, ref structInput, Marshal.SizeOf(new INPUT()));
            }
            if (Alt)
            {
                structInput.ki.wVk = (ushort)VK.MENU;
                intReturn = SendInput(1, ref structInput, Marshal.SizeOf(new INPUT()));
            }
            if (Win)
            {
                structInput.ki.wVk = (ushort)VK.LWIN;
                intReturn = SendInput(1, ref structInput, Marshal.SizeOf(new INPUT()));
            }

            



        }

        private void notifyIcon1_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            if (this.WindowState == FormWindowState.Minimized)
            {
                this.Show();
                this.WindowState = FormWindowState.Normal;
            }
            
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void Form1_ResizeEnd(object sender, EventArgs e)
        {
            if (this.WindowState == FormWindowState.Minimized)
                this.Hide();

        }






    }
}
